{ stdenv, fetchurl, undmg, unzip, version ? "2.2.4", ... }:

stdenv.mkDerivation {
  inherit version;
  pname = "cinny";
  nativeBuildInputs = [ undmg unzip ];
  src = fetchurl {
    url =
      "https://github.com/cinnyapp/cinny-desktop/releases/download/v${version}/Cinny_desktop-x86_64.dmg";
    sha256 = "sha256-m8sYA7YjvhqGFuU1L1y7BtndHGd6MpuH+hKzPSukxD0=";
  };

  sourceRoot = ".";

  installPhase = ''
    runHook preInstall

    mkdir -p $out/Applications
    cp -r Cinny.app $out/Applications/Cinny.app

    runHook postInstall
  '';
}
